import re
import sys
import random



def write_lines(filename, data_lines):

    with open(filename, 'w') as f:
        f.write(' '.join(data_lines))
        f.write('\n')        


def match_word(text, word):
    return re.search(r'\b{0}\b'.format(word), text)


def split_sentences(filename):
    
    with open(filename, 'r') as f:
        data = f.read()
    data = data.replace('\n', ' ')
    parsed = re.split(r'([.!?])', data)

    text   = parsed[0::2]
    ending = parsed[1::2]
    
    return [t+e for t, e in zip(text, ending)]


if __name__ == '__main__':
    if len(sys.argv) < 3:
        print('usage: {0} input_file word'.format(sys.argv[0]))
        sys.exit()

    filename = sys.argv[1]
    word = sys.argv[2]
    basename, ext = filename.rsplit('.', 1)
    outfile = "{0}_{1}.{2}".format(basename, word, ext)
        
    lines = split_sentences(filename)  
    target_lines = [line.strip() for line in lines if match_word(line, word)]    
    random.shuffle(target_lines)
    write_lines(outfile, target_lines)
    
    
